package com.example.fuzzControll.service.impl;

import com.example.fuzzControll.conf.SeedProperties;
import com.example.fuzzControll.constents.CmdConstent;
import com.example.fuzzControll.exception.CmdException;
import com.example.fuzzControll.exception.FileException;
import com.example.fuzzControll.service.SeedFileService;
import com.example.fuzzControll.tools.CmdTools;
import com.example.fuzzControll.tools.FileTools;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.util.ArrayList;
import java.util.List;

@Service
public class SeedFileServiceImpl implements SeedFileService {
    CmdTools cmdTools = new CmdTools();
    FileTools fileTools = new FileTools();
    @Autowired
    SeedProperties properties;

    @Override
    public List<String> getSeedFiles() throws CmdException{
        return cmdTools.runCmd(CmdConstent.GET_FILE_NAME + properties.getSeedPath());
    }

    //todo 同步修改可能会出现问题
    @Override
    public void delFile(String fileName) throws CmdException {
        int fileCountBefore = getSeedFileCount();
        cmdTools.runCmd(CmdConstent.DELETE_FILE + properties.getSeedPath() + "/" + fileName);
        int fileCountAfter = getSeedFileCount();
        if(fileCountAfter==fileCountBefore){
            throw new CmdException("delete cmd error !The file has not changed.");
        }
    }

    @Override
    public void upload(MultipartFile file) throws FileException {
        int fileCountBefore = getSeedFileCount();
        fileTools.load(file);
        int fileCountAfter = getSeedFileCount();
        if(fileCountAfter==fileCountBefore){
            throw new CmdException("upload file error !The file failed to be submitted.");
        }
    }

    /**
     *
     * 获取种子文件目录下文件数量
     */
    @Override
    public int getSeedFileCount() throws CmdException {
        List<String> files = cmdTools.runCmd(CmdConstent.GET_FILE_NAME+ properties.getSeedPath());
        int count = files.size();
        return count;
    }
}
